<template>
  <div>
    <component :is="layout" />
    <v-main class="main-content">
      <router-view />
    </v-main>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
import TutorLayout from '@/pages/tutor/TutorLayout'
import StudentLayout from '@/pages/student/StudentLayout'
import ReviewerLayout from '@/pages/reviewer/ReviewerLayout'
import { Authentication } from '@/store/modules/authentication'

export default {
  name: 'LayoutSelector',
  components: {
    ReviewerLayout,
    StudentLayout,
    TutorLayout },
  computed: {
    isStudent () { return Authentication.isStudent },
    isTutor () { return Authentication.isTutor },
    isReviewer () { return Authentication.isReviewer },
    layout () {
      if (this.isStudent) {
        return 'student-layout'
      } else if (this.isTutor) {
        return 'tutor-layout'
      } else if (this.isReviewer) {
        return 'reviewer-layout'
      }

      return undefined
    }
  }
}
</script>

<style>
  html {
    /* Vuetify always shows the scrollbar by default. This disables it. */
    overflow-y: auto !important;
  }
</style>

<style scoped>
  /* Move the scrollbar below the header so it doesn't jump around when no scrollbar is shown. */
  .main-content {
    /* 48px is the vuetify header size.  */
    height: calc(100vh - 48px);
    margin-top: 48px;
    padding-top: 0 !important;
    overflow: auto;
  }
</style>
